## gprbuild 2021.0.0.0778b109

=== Makefile ===
# Makefile targets
# ----------------
#
# Setup:                   make [VAR=VALUE] setup (see below)
# Build gprbuild:          make all
# Install gprbuild:        make install
# Create gprbuild package: make distall
# Build tool <TOOL>:       make <TOOL>
# Build libgpr:            make libgpr.build
# Install libgpr:          make libgpr.install
# (for libgpr you can add ".type" where type is static, static-pic or shared
#  build a specific version of the lib. by default all supported variants are
#  built).

# Variables which can be set:
#
#   ENABLE_SHARED : yes / no (or empty)
#   BUILD         : debug production coverage profiling
#   PROCESSORS    : nb parallel compilations (0 to use all cores)
#   TARGET        : target triplet for cross-compilation
#
# Out-of-tree build:
#
#   $ make -f <GPRBUILD_TREE>/Makefile setup
#   $ make -f <GPRBUILD_TREE>/Makefile

HOST    = $(shell gcc -dumpmachine)
TARGET := $(shell gcc -dumpmachine)

prefix	      := $(dir $(shell which gnatls))..
BUILD         = production
PROCESSORS    = 0
BUILD_DIR     =
SOURCE_DIR    := $(shell dirname "$(MAKEFILE_LIST)")
LIB_DIR       = lib/

# Load current setup if any
-include makefile.setup

# target options for cross-build
ifeq ($(HOST),$(TARGET))
GTARGET=
INSTALLER=exe/$(BUILD)/$(LIB_INSTALLER)
else
GTARGET=--target=$(TARGET)
INSTALLER=$(LIB_INSTALLER)
endif

EXEC_INSTALLER=$(INSTALLER) -XBUILD=${BUILD}

# check for out-of-tree build
ifeq ($(SOURCE_DIR),.)
RBD=
GPRBUILD_GPR=gprbuild.gpr
GPR_GPR=gpr/gpr.gpr
MAKEPREFIX=
else
RBD=--relocate-build-tree
GPRBUILD_GPR=$(SOURCE_DIR)/gprbuild.gpr
GPR_GPR=$(SOURCE_DIR)/gpr/gpr.gpr
MAKEPREFIX=$(SOURCE_DIR)/
endif

ENABLE_SHARED := $(shell gprbuild $(GTARGET) -c -q -p \
	-P$(MAKEPREFIX)config/test_shared 2>/dev/null && echo "yes")

ifeq ($(ENABLE_SHARED), yes)
   LIBGPR_TYPES=static shared static-pic
else
   LIBGPR_TYPES=static
endif

# Used to pass extra options to GPRBUILD, like -d for instance
GPRBUILD_OPTIONS=

BUILDER=gprbuild -p -m $(GTARGET) $(RBD) -j${PROCESSORS} -XBUILD=${BUILD} ${GPRBUILD_OPTIONS}
LIB_INSTALLER=gprinstall -p -f --target=$(TARGET) $(RBD) --prefix=${prefix}
CLEANER=gprclean -q $(RBD)

GPRBUILD_BUILDER=$(BUILDER) $(GPRBUILD_GPR) \
	-XLIBRARY_TYPE=static -XXMLADA_BUILD=static
LIBGPR_BUILDER=$(BUILDER) $(GPR_GPR)
LIBGPR_INSTALLER=$(LIB_INSTALLER) $(GPR_GPR) -XBUILD=${BUILD} \
	--install-name=gpr \
	--build-var=LIBRARY_TYPE --build-var=GPR_BUILD $(GTARGET)
LIBGPR_UNINSTALLER=$(LIB_INSTALLER) $(GPR_GPR) --install-name=gpr --uninstall

#########
# build #
#########

.PHONY: all distall gprbuild gprconfig gprclean gprinstall gprname gprls

build all:
	$(GPRBUILD_BUILDER)

distall: all install

gprbuild:
	$(GPRBUILD_BUILDER) gprbuild-main.adb

gprinstall:
	$(GPRBUILD_BUILDER) gprinstall-main.adb

gprclean:
	$(GPRBUILD_BUILDER) gprclean-main.adb

gprconfig:
	$(GPRBUILD_BUILDER) gprconfig-main.adb

gprname:
	$(GPRBUILD_BUILDER) gprname-main.adb

gprls:
	$(GPRBUILD_BUILDER) gprls-main.adb

#################################
# Gprbuild installation targets #
#################################

.PHONY: install

install:
	$(EXEC_INSTALLER) --mode=usage --install-name=gprbuild \
		-XINSTALL_MODE=nointernal $(GPRBUILD_GPR)
	$(EXEC_INSTALLER) --target=$(TARGET) --mode=usage  --install-name=gprbuild \
		-XINSTALL_MODE=internal $(GPRBUILD_GPR)

complete: all install libgpr.install.static

##########
# Libgpr #
##########

.PHONY: libgpr.build libgpr.build.static libgpr.build.shared libgpr.build.static-pic
.PHONY: libgpr.install libgpr.install.static libgpr.install.shared libgpr.install.static-pic
.PHONY: libgpr.uninstall

libgpr.build: $(foreach t, $(LIBGPR_TYPES), libgpr.build.$(t))

libgpr.build.shared:
	${LIBGPR_BUILDER} -XLIBRARY_TYPE=relocatable \
		-XXMLADA_BUILD=relocatable

libgpr.build.static:
	${LIBGPR_BUILDER} -XLIBRARY_TYPE=static \
		-XXMLADA_BUILD=static

libgpr.build.static-pic:
	${LIBGPR_BUILDER} -XLIBRARY_TYPE=static-pic \
		-XXMLADA_BUILD=static-pic

libgpr.install: libgpr.uninstall $(foreach t, $(LIBGPR_TYPES), libgpr.install.$(t))

libgpr.install.static:
	$(LIBGPR_INSTALLER) \
	   -XLIBRARY_TYPE=static \
	   -XXMLADA_BUILD=static \
	   --lib-subdir=${LIB_DIR}/gpr/static \
	   --build-name=static

libgpr.install.static-pic:
	$(LIBGPR_INSTALLER) \
	   -XLIBRARY_TYPE=static-pic \
	   -XXMLADA_BUILD=static-pic \
	   --lib-subdir=${LIB_DIR}/gpr/static-pic \
	   --build-name=static-pic

libgpr.install.shared:
	$(LIBGPR_INSTALLER) \
	   -XLIBRARY_TYPE=relocatable \
	   -XXMLADA_BUILD=relocatable \
	   --lib-subdir=${LIB_DIR}/gpr/relocatable \
	   --build-name=relocatable

libgpr.uninstall:
	-$(LIBGPR_UNINSTALLER)

libgpr.clean:
	-$(CLEANER) -XLIBRARY_TYPE=relocatable $(GPR_GPR)
	-$(CLEANER) -XLIBRARY_TYPE=static $(GPR_GPR)
	-$(CLEANER) -XLIBRARY_TYPE=static-pic $(GPR_GPR)
	rm -fr gpr/lib gpr/libobj

#########
# setup #
#########

.SILENT: setup
setup:
	echo "prefix=$(prefix)" > makefile.setup
	echo "ENABLE_SHARED=$(ENABLE_SHARED)" >> makefile.setup
	echo "BUILD=$(BUILD)" >> makefile.setup
	echo "PROCESSORS=$(PROCESSORS)" >> makefile.setup
	echo "TARGET=$(TARGET)" >> makefile.setup
	echo "SOURCE_DIR=$(SOURCE_DIR)" >> makefile.setup

###################
# Cleanup targets #
###################

.PHONY: clean
clean: libgpr.clean
	-$(CLEANER) -r -Pgprbuild -XBUILD=$(BUILD)
	-$(CLEANER) -r -XBUILD=${BUILD} \
		-XLIBRARY_TYPE=static-pic $(GPR_GPR)
	-$(CLEANER) -r -XBUILD=${BUILD} \
		-XLIBRARY_TYPE=static $(GPR_GPR)
ifeq ($(ENABLE_SHARED), yes)
	-$(CLEANER) -r -XBUILD=${BUILD} \
		-XLIBRARY_TYPE=relocatable $(GPR_GPR)
	-$(CLEANER) $(GPR_GPR) -XBUILD=$(BUILD) \
		-XLIBRARY_TYPE=relocatable
endif
	make -C $(MAKEPREFIX)doc clean
	make -C $(MAKEPREFIX)examples clean
	rm -fr obj exe makefile.setup

.PHONY: doc examples

doc:
	make -C $(MAKEPREFIX)doc

examples: force
	make -C $(MAKEPREFIX)examples

force:

# Let gprbuild handle parallelization. In general, we don't support parallel
# runs in this Makefile, as concurrent gprinstall processes may crash.
.NOTPARALLEL:

=== doc/Makefile ===
# Makefile for Sphinx documentation

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = .
SOURCEDIR     = .

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) \
		  -c $(SOURCEDIR)/share \
		  -d $(BUILDDIR)/$*/doctrees \
		  $(SOURCEDIR)
FMT_LIST=html txt info pdf
DOC_NAME=gprbuild_ug
CP=cp

.PHONY: help clean

all: $(foreach fmt, $(FMT_LIST), $(fmt))

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  pdf        to make LaTeX files and run them through pdflatex"
	@echo "  txt        to make text files"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make info files"
	@echo "  all                 to build documentation in all formats"
	@echo ""
	@echo "source and location can be overriden using SOURCEDIR and BUILDDIR variables"

clean:
	-rm -rf $(BUILDDIR)/html \
		$(BUILDDIR)/pdf \
		$(BUILDDIR)/txt \
		$(BUILDDIR)/info \
		$(BUILDDIR)/doctrees

html: force
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html

pdf: force
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/pdf
	cp $(SOURCEDIR)/share/sphinx.sty $(BUILDDIR)/pdf
	$(MAKE) -C $(BUILDDIR)/pdf all-pdf LATEXOPTS="-interaction=nonstopmode"

txt: force
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/$*/txt
	$(MAKE) -C $(BUILDDIR)/txt plaintext

info: force
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/$*/info
	$(MAKE) -C $(BUILDDIR)/info info

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/$*/texinfo

force:

=== examples/extended_projects/Makefile ===
all: ../subsystems/default.cgpr
	gprbuild -p -Pnew_ada_main --config=../subsystems/default.cgpr

../subsystems/default.cgpr:
	make -C ../subsystems default.cgpr

clean:
	gprclean -r -Pnew_ada_main --config=../subsystems/default.cgpr


run: all
	./ada_main

=== examples/namings/Makefile ===
all: default.cgpr
	gprbuild -p -Pnamings -XC1=case1
	gprbuild -p -Pnamings -XC1=case2
	gprbuild -p -Pnamings -XC1=case3

default.cgpr:
	gprconfig --batch --config Ada  --config C -o $@

clean: force
	gprclean -Pnamings -XC1=case1
	gprclean -Pnamings -XC1=case2
	gprclean -Pnamings -XC1=case3
	$(RM) default.cgpr

run: all
	./main-case1
	./main-case2
	./main-case3
force:

=== examples/scenarios/Makefile ===
all: default.cgpr
	gprbuild -p main.gpr -XLIB=static
	gprbuild -p main.gpr -XLIB=dynamic


default.cgpr:
	gprconfig --batch --config Ada  --config C -o $@

clean: force
	gprclean -r main.gpr -XLIB=static
	gprclean -r main.gpr -XLIB=dynamic
	$(RM) default.cgpr

run: all
	./obj/main
	(PATH="../libraries/lib2:${PATH}" obj1/main)

force:

=== debian/changelog ===
gprbuild (2021.0.0.0778b109-5) unstable; urgency=medium

  * Fix dependencies for examples autopkgtest. Closes: #977551.

 -- Nicolas Boulenguez <nicolas@debian.org>  Mon, 21 Dec 2020 12:30:43 +0000

gprbuild (2021.0.0.0778b109-4) unstable; urgency=medium

  * Fix dependencies for gpr-wrapper autopkgtest. Closes: #977551.
  * Standards-Version: 4.5.1.

 -- Nicolas Boulenguez <nicolas@debian.org>  Wed, 16 Dec 2020 23:07:44 +0000

gprbuild (2021.0.0.0778b109-3) unstable; urgency=medium

  * Reupload to unstable for gnat-10 transition.
  * Add myself to Uploaders.

 -- Ludovic Brenta <lbrenta@debian.org>  Fri, 11 Dec 2020 09:19:32 +0100

gprbuild (2021.0.0.0778b109-2) experimental; urgency=medium

  * Build-Depend: libxmlada (>= 21), fixing the build of indirect reverse
    dependencies in experimental where ALI versions do not change.
  * Install compatibility gpr.gpr referencing gnatprj.gpr.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 15 Nov 2020 17:22:29 +0000

gprbuild (2021.0.0.0778b109-1) experimental; urgency=medium

  * New upstream snapshot (no ALI/SO bump in experimental).
    Adapt ada-lib-info-source-date-epoch.diff to nanosecond precision.
  * Upstream now grants the GCC runtime exception to GPL-3+.
    Relicense Debian packaging accordingly.
  * Upstream removes invariant sections from GFDL-1.3+.
    Add a Debian -doc package for the user guide and move examples there.
    New patches: doc-conf-python3, doc-conf-sphinx4, clean-pycache.
  * Upstream distributes gprconfig-kb separately.
  * Upstream does not regenerate gpr-snames anymore.
  * tests: check installed examples instead of using source tree.
  * Upstream recommends to watch github instead of the community website.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 18 Oct 2020 12:54:06 +0000

gprbuild (2020-1) experimental; urgency=medium

  * New upstream version built with gnat-10.
    Rename lib and -dev package in experimental.
  * Sync SOURCE_DATE_EPOCH patch with equivalent gcc-10 patch.
  * Rebase archive-builder.diff as in upstream merge request.
  * Sync shared part of debian/rules with libxmlada.

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 21 May 2020 14:11:33 +0000

=== debian/control ===
Source: gprbuild
Section: devel
Priority: optional
Maintainer: Nicolas Boulenguez <nicolas@debian.org>
Uploaders: Ludovic Brenta <lbrenta@debian.org>
Build-Depends:
 debhelper-compat (= 13),
Build-Depends-Arch:
 gnat,
# d/rules extracts ALI versions from these lines:
 gnat-10,
 libxmlada-dom10-dev (>= 21),
 libxmlada-input10-dev (>= 21),
 libxmlada-sax10-dev (>= 21),
 libxmlada-schema10-dev (>= 21),
# libxmlada_unicode is required indirectly
Build-Depends-Indep:
 dh-sequence-sphinxdoc,
# Sphinx >= 1.6 uses the latexmk driver:
 latexmk,
 python3-sphinx,
# makeinfo:
 texinfo,
# ptmr8t.tfm:
 texlive-fonts-recommended,
# fncychap.sty:
 texlive-latex-extra,
Standards-Version: 4.5.1
Rules-Requires-Root: no
Homepage: https://github.com/AdaCore/gprbuild
Vcs-Browser: https://salsa.debian.org/debian/gprbuild
Vcs-Git: https://salsa.debian.org/debian/gprbuild.git

Package: libgnatprj8
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: support for programs processing GNAT projects (runtime)
 GNAT projects are human-readable text files used to drive tools
 building or inspecting lots of source files in several programming
 languages, like those provided by the gprbuild package.
 .
 This package contains the runtime shared library.

Package: libgnatprj8-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, ${ada:Depends}
Suggests: gprbuild-doc
Description: support for programs processing GNAT projects (development)
 GNAT projects are human-readable text files used to drive tools
 building or inspecting lots of source files in several programming
 languages, like those provided by the gprbuild package.
 .
 This package contains the development tools.

Package: gprbuild
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, gprconfig-kb
Suggests: gnat (>= 5), g++, gcc, gfortran, gprbuild-doc
# Previous gnat-x.y used x.y instead of x to name tools and libs.
Description: multi-language extensible build tool
 A set of tools for processing GNAT project files:
 gprconfig detects available compilers,
 gprbuild runs them;
 gprslave helps distributing the build work across the network;
 gprinstall copies the objects to their final destination;
 gprclean removes them.
 The default configuration supports Ada, Assembler, C, C++, Fortran,
 and can be extended to support user source processing tools.

Package: gprbuild-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, ${sphinxdoc:Depends},
Built-Using: ${sphinxdoc:Built-Using}
Suggests: gprbuild
# Examples were in the gprbuild package when there was no -doc package.
Replaces: gprbuild (<< 2021.0.0.0778b109-1)
Breaks:   gprbuild (<< 2021.0.0.0778b109-1)
Description: multi-language extensible build tool (documentation)
 A set of tools for processing GNAT project files:
 gprconfig detects available compilers,
 gprbuild runs them;
 gprslave helps distributing the build work across the network;
 gprinstall copies the objects to their final destination;
 gprclean removes them.
 The default configuration supports Ada, Assembler, C, C++, Fortran,
 and can be extended to support user source processing tools.
 .
 This package contains the documentation.

=== debian/rules ===
#!/usr/bin/make -f
# Build script for GPRBuild in Debian.
# Copyright (c) 2009-2012 Stephen Leake <stephen_leake@stephe-leake.org>
# Copyright (c) 2013-2020 Nicolas Boulenguez <nicolas@debian.org>

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.

# On Debian systems, the full text of the GPL is in the file
# /usr/share/common-licenses/GPL-3.

# NOTE:
# In order to prevent a circular build-dependency, the Debian packages
# for XML/Ada and GPRBuild bother to build without project support.
# Please keep the two debian/rules files similar enough to ease
# backport of good ideas.

######################################################################
# Read some variables from the Debian control file.
# To debug, replace eval with error.
$(foreach line,$(shell sed -n ' \
  s/^Package: \(libgnatprj\([0-9.]\+\)\)$$/ \
    gnatprj_LIB_PKG:=\1 \
    gnatprj_SONAME:=libgnatprj.so.\2 \
   /p;\
  s/^Package:\s*\(libgnatprj[0-9.]\+-dev\)$$/ \
    gnatprj_DEV_PKG:=\1 \
   /p;\
  s/^ gnat-\([0-9.]\+\),\?$$/ \
    GNAT_VERSION:=\1 \
   /p;\
  s/^ \(libxmlada-\([a-z]\+\)[0-9.]\+-dev\)\( (.*)\)\?,\?$$/ \
    xmlada_\2_DEV_PKG:=\1 \
   /p;\
  ' debian/control),$(eval $(line)))

DEB_BUILD_MAINT_OPTIONS := hardening=+all
DEB_ADAFLAGS_MAINT_APPEND := -gnatwa -Wall -gnatn
DEB_LDFLAGS_MAINT_APPEND := \
  -Wl,--no-undefined \
  -Wl,--no-copy-dt-needed-entries \
  -Wl,--no-allow-shlib-undefined
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk
include $(wildcard /usr/share/ada/debian_packaging-$(GNAT_VERSION).mk)
# wildcard in case only Build-Depends-Indep are installed.

# gprbuild.gpr selects inlining.
# It also selects -E -static binder options, but:
# #666106 affects only kfreebsd-i386, where storing tracebacks in
# exception occurrences causes a segmentation fault.  This prevents
# handling of any exceptions.  gprconfig relies on handling exceptions
# when parsing compilers.xml.
# Author: Ludovic Brenta <lbrenta@debian.org>

######################################################################
%:
	dh $@

# Rewrite upstream configure/make build system.
.PHONY: $(addprefix override_dh_auto_, \
  configure build-arch build-indep test install clean)

# Rewrite upstream targets without gprbuild or gprclean.
# gnatmake does not support projects anymore, we cannot use xmlada.gpr.

######################################################################
ADS_DIR := usr/share/ada/adainclude
GPR_DIR := usr/share/gpr
ALI_DIR := usr/lib/$(DEB_HOST_MULTIARCH)/ada/adalib
SO_DIR  := usr/lib/$(DEB_HOST_MULTIARCH)
A_DIR   := usr/lib/$(DEB_HOST_MULTIARCH)

# For source directories (-aI) and ALI directories (-aO), blindly list
# all build dependencies and append each library once it is
# built. This does not hurt, and covers all direct and indirect
# dependencies.

# For installed shared libraries (-l) and locally built shared
# objects), the same strategy works thanks to --as-needed, which is
# the default since gcc-9, provided a proper ordering.

# Libraries provided by Ada -dev packages in Build-Depends.
ada_build_deps := xmlada_schema xmlada_dom xmlada_sax xmlada_input xmlada_unicode

ada_build_deps_includes := $(foreach l,$(ada_build_deps),-aI/$(ADS_DIR)/$(l) -aO/$(ALI_DIR)/$(l))
ada_build_deps_ldlibs := $(addprefix -l,$(ada_build_deps) gnarl-$(GNAT_VERSION) gnat-$(GNAT_VERSION))

# These lists grow at the end of the template.
includes_so_far :=
shared_objects_so_far :=

define library_template
# Parameters:
# _SRCDIR: directory containing the sources files
# _SONAME : shared object name (libNAME.so.VERSION)
# _DEV_PKG, _LIB_PKG: as in policy
# For installed projects and ada:Depends, we need an explicit list of
# the dependencies that the library *directly* reference.
# _deps_int_direct: among the local libraries built so far
# _deps_ext_direct: among ada_build_deps (each one must have a _DEV_PKG)

  # Remove pure specifications and separate compilation units.
  $(library)_unit_bodies := $(shell grep -L '^separate ' $($(library)_SRCDIR)/*.adb)

  $(library)_c_sources := $(wildcard $($(library)_SRCDIR)/*.c)

  # Build dynamic library.
  override_dh_auto_build-arch: obj/shared/$($(library)_SONAME)
  obj/shared/$($(library)_SONAME): \
        $$(patsubst $($(library)_SRCDIR)/%.c,obj/shared_$(library)_obj/%.o,$$($(library)_c_sources)) \
        $(shared_objects_so_far) \
        | obj/shared obj/shared_$(library)_ali obj/shared_$(library)_obj
    # -fPIC/-shared overrides -fPIE/-pie in ADAFLAGS/LDFLAGS.
	gnatmake -c $$($(library)_unit_bodies) -D obj/shared_$(library)_obj \
	  $(BUILDER_OPTIONS) $(includes_so_far) $(ada_build_deps_includes) \
	  -cargs $(ADAFLAGS) -fPIC
	gcc-$(GNAT_VERSION) $(LDFLAGS) -shared \
	  -o $$@ \
	  -Wl,-soname,$($(library)_SONAME) \
	  obj/shared_$(library)_obj/*.o \
	  $(shared_objects_so_far) $(ada_build_deps_ldlibs)
  # Create development link so that the other libraries may link with it.
	ln -fs $($(library)_SONAME) obj/shared/lib$(library).so
  # Move ALI files to library directory and mark them read-only.
	mv obj/shared_$(library)_obj/*.ali obj/shared_$(library)_ali
	chmod 444 obj/shared_$(library)_ali/*
  # Work-around until BUILD_PATH_PREFIX_MAP is accepted in GCC.
	sed -i '/^A -f[a-z]+-prefix-map=/d' obj/shared_$(library)_ali/*

  # Build static library.
  override_dh_auto_build-arch: obj/static/lib$(library).a
  # There is no link step, but listing shared objects built so far as
  # prerequisites forces Make to first build their .ali, so that this
  # gnatmake run does not compile them.
  obj/static/lib$(library).a: \
         $$(patsubst $($(library)_SRCDIR)/%.c,obj/static_$(library)_obj/%.o,$$($(library)_c_sources)) \
         $(shared_objects_so_far) \
        | obj/static obj/static_$(library)_ali obj/static_$(library)_obj
	gnatmake -c $$($(library)_unit_bodies) -D obj/static_$(library)_obj \
	  $(BUILDER_OPTIONS) $(includes_so_far) $(ada_build_deps_includes) \
	  -cargs $(ADAFLAGS)
	ar rc $$@ obj/static_$(library)_obj/*.o
	ranlib $$@

  obj/shared_$(library)_obj/%.o: $($(library)_SRCDIR)/%.c | obj/shared_$(library)_obj
	gcc-$(GNAT_VERSION) -c $(CFLAGS) $(CPPFLAGS) $$< -o $$@ -fPIC
  obj/static_$(library)_obj/%.o: $($(library)_SRCDIR)/%.c | obj/static_$(library)_obj
	gcc-$(GNAT_VERSION) -c $(CFLAGS) $(CPPFLAGS) $$< -o $$@

  obj/shared_$(library)_ali obj/shared_$(library)_obj obj/static_$(library)_ali obj/static_$(library)_obj: | obj
	mkdir $$@

  execute_after_dh_install::
  # dynamic library
	dh_install --package=$($(library)_LIB_PKG) \
	  obj/shared/$($(library)_SONAME) \
	  $(SO_DIR)
  # static library
	dh_install --package=$($(library)_DEV_PKG) \
	  obj/static/lib$(library).a \
	  $(A_DIR)
  # development symbolic link
	dh_link --package=$($(library)_DEV_PKG) \
	  $(SO_DIR)/$($(library)_SONAME) \
	  $(SO_DIR)/lib$(library).so
  # ALI files
	dh_install --package=$($(library)_DEV_PKG) \
	  obj/shared_$(library)_ali/*.ali \
	  $(ALI_DIR)/$(library)
  # Sources
	dh_install --package=$($(library)_DEV_PKG) \
	  $($(library)_SRCDIR)/*.ad[bs] $$($(library)_c_sources) \
	  $(ADS_DIR)/$(library)
  # Substitution variables for the control file.
	echo 'ada:Depends=gnat, gnat-$(GNAT_VERSION), \
	  $(foreach l, $($(library)_deps_int_direct), $($(l)_DEV_PKG) (=$$$${binary:Version}),) \
	  $(foreach l, $($(library)_deps_ext_direct), $($(l)_DEV_PKG),) \
	  $($(library)_LIB_PKG)' \
	  >> debian/$($(library)_DEV_PKG).substvars

  # Externally built project installed for end users.
  override_dh_auto_build-arch: obj/$(library).gpr
  obj/$(library).gpr: debian/template.gpr | obj
	sed ' \

=== debian/tests/control ===
Tests: archive-builder
Depends: gprbuild, gcc

Tests: ada-policy-project-with-dash-s link-with-shared gpr-wrapper
Depends: @, gnat

Tests: link-library-as-needed-z-defs source-date-epoch
Depends: gprbuild, gnat

Tests: examples
Depends: gprbuild, gnat, gcc, g++, gfortran, make, gprbuild-doc

Tests: do-not-strip-minor-soversion
Depends: gprbuild, gnat, binutils

=== debian/watch ===
version=4

# For historical reasons, DEB_VERSION_UPSTREAM starts with "20".

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%gprbuild-$1.tar.gz%,\
      dversionmangle=s/^20//" \
https://github.com/AdaCore/gprbuild/tags \
(?:.*?/)?v?(\d[\d.]*)\.tar\.gz

## gprbuild 2022.0.0

=== Makefile ===
--- 
+++ 
@@ -74,7 +74,7 @@
 GPRBUILD_OPTIONS=
 
 BUILDER=gprbuild -p -m $(GTARGET) $(RBD) -j${PROCESSORS} -XBUILD=${BUILD} ${GPRBUILD_OPTIONS}
-LIB_INSTALLER=gprinstall -p -f --target=$(TARGET) $(RBD) --prefix=${prefix}
+LIB_INSTALLER=gprinstall -p -f --target=$(TARGET) $(RBD) "--prefix=${prefix}"
 CLEANER=gprclean -q $(RBD)
 
 GPRBUILD_BUILDER=$(BUILDER) $(GPRBUILD_GPR) \

=== debian/changelog ===
gprbuild (2022.0.0-8) unstable; urgency=medium

  * Remove support for gnatgcc as a compiler in gprconfig-kb
  * Add autopkgtest for a project mixing Ada and C
  * Update README.Debian

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 14 Jul 2022 18:35:33 +0200

gprbuild (2022.0.0-7) unstable; urgency=medium

  * Disable parallelism in Make, reenable it in sphinx.
    The failure of 2022.0.0-6 disculps sphinx-doc of #1008152.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 07 Jun 2022 16:27:42 +0000

gprbuild (2022.0.0-6) unstable; urgency=medium

  * Disable parallelism when building sphinx documentation, hopefully
    avoiding to trigger #1008152 again.

 -- Nicolas Boulenguez <nicolas@debian.org>  Mon, 06 Jun 2022 22:08:00 +0000

gprbuild (2022.0.0-5) unstable; urgency=medium

  * Fix regular expression removing -prefix-map lines from .ali files

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 31 May 2022 02:18:33 +0200

gprbuild (2022.0.0-4) unstable; urgency=medium

  * Reupload to unstable for the gnat-11 transition
  * Configure branch names for git-buildpackage

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 08 May 2022 18:04:52 +0200

gprbuild (2022.0.0-3) experimental; urgency=medium

  * Let -dev packages depend on 'gnat (>= X), gnat (<< X+1)' instead of
    'gnat, gnat-X'.  See https://bugs.debian.org/bug=975589#24.
  * Override dh_gencontrol instead of appending to .substvars, in order to
    increase log readability and prevent multiple inclusions.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 26 Apr 2022 13:19:47 +0000

gprbuild (2022.0.0-2) experimental; urgency=medium

  * Rebuild with gnat-11 (>= 11.2.0-19).
    A change in s-oscons.ads breaks ALI checksums.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 03 Apr 2022 12:02:43 +0000

gprbuild (2022.0.0-1) experimental; urgency=medium

  * Build new upstream release with gnat-11 in experimental.
  * Rename lib and -dev packages per Ada policy.
  * Adapt to changes in debian_packaging.mk.
  * Install gprbind and gprlib to /usr/libexec instead of /usr/lib.
    Depend on a version of gprconfig-kb aware of this. Closes: #998628.
  * Build-Depend: tex-gyre. Closes: #997415.
  * Drop obsolete version restriction in Build-Depends.
  * Add copyright stanza for an unused copy of sphinx.sty.
  * Add upstream metadata.
  * Remove unneeded filenamemangle uscan option.
  * Update standards version, patch status.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 13 Mar 2022 12:39:17 +0000

=== debian/control ===
--- 
+++ 
@@ -8,11 +8,12 @@
 Build-Depends-Arch:
  gnat,
 # d/rules extracts ALI versions from these lines:
- gnat-10,
- libxmlada-dom10-dev (>= 21),
- libxmlada-input10-dev (>= 21),
- libxmlada-sax10-dev (>= 21),
- libxmlada-schema10-dev (>= 21),
+# A change in s-oscons.ads breaks ALI checksums:
+ gnat-11 (>= 11.2.0-19),
+ libxmlada-dom11-dev,
+ libxmlada-input11-dev,
+ libxmlada-sax11-dev,
+ libxmlada-schema11-dev,
 # libxmlada_unicode is required indirectly
 Build-Depends-Indep:
  dh-sequence-sphinxdoc,
@@ -21,17 +22,19 @@
  python3-sphinx,
 # makeinfo:
  texinfo,
+# documentation depends on tgtermes.sty:
+ tex-gyre,
 # ptmr8t.tfm:
  texlive-fonts-recommended,
 # fncychap.sty:
  texlive-latex-extra,
-Standards-Version: 4.5.1
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Homepage: https://github.com/AdaCore/gprbuild
 Vcs-Browser: https://salsa.debian.org/debian/gprbuild
 Vcs-Git: https://salsa.debian.org/debian/gprbuild.git
 
-Package: libgnatprj8
+Package: libgnatprj9
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -43,7 +46,7 @@
  .
  This package contains the runtime shared library.
 
-Package: libgnatprj8-dev
+Package: libgnatprj9-dev
 Section: libdevel
 Architecture: any
 Depends: ${misc:Depends}, ${ada:Depends}
@@ -57,9 +60,10 @@
 
 Package: gprbuild
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, gprconfig-kb
-Suggests: gnat (>= 5), g++, gcc, gfortran, gprbuild-doc
-# Previous gnat-x.y used x.y instead of x to name tools and libs.
+Depends: ${shlibs:Depends}, ${misc:Depends},
+# 22.0.0-5 nevers calls gnatgcc
+ gprconfig-kb (>= 22.0.0-5),
+Suggests: gnat, g++, gcc, gfortran, gprbuild-doc
 Description: multi-language extensible build tool
  A set of tools for processing GNAT project files:
  gprconfig detects available compilers,
@@ -79,7 +83,7 @@
 Suggests: gprbuild
 # Examples were in the gprbuild package when there was no -doc package.
 Replaces: gprbuild (<< 2021.0.0.0778b109-1)
-Breaks:   gprbuild (<< 2021.0.0.0778b109-1)
+Breaks: gprbuild (<< 2021.0.0.0778b109-1)
 Description: multi-language extensible build tool (documentation)
  A set of tools for processing GNAT project files:
  gprconfig detects available compilers,

=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #!/usr/bin/make -f
 # Build script for GPRBuild in Debian.
 # Copyright (c) 2009-2012 Stephen Leake <stephen_leake@stephe-leake.org>
-# Copyright (c) 2013-2020 Nicolas Boulenguez <nicolas@debian.org>
+# Copyright (c) 2013-2022 Nicolas Boulenguez <nicolas@debian.org>
 
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -33,7 +33,7 @@
   s/^Package:\s*\(libgnatprj[0-9.]\+-dev\)$$/ \
     gnatprj_DEV_PKG:=\1 \
    /p;\
-  s/^ gnat-\([0-9.]\+\),\?$$/ \
+  s/^ gnat-\([0-9.]\+\)\( (.*)\)\?,\?$$/ \
     GNAT_VERSION:=\1 \
    /p;\
   s/^ \(libxmlada-\([a-z]\+\)[0-9.]\+-dev\)\( (.*)\)\?,\?$$/ \
@@ -49,7 +49,8 @@
   -Wl,--no-allow-shlib-undefined
 include /usr/share/dpkg/architecture.mk
 include /usr/share/dpkg/buildflags.mk
-include $(wildcard /usr/share/ada/debian_packaging-$(GNAT_VERSION).mk)
+include /usr/share/dpkg/buildopts.mk
+include $(wildcard /usr/share/ada/debian_packaging.mk)
 # wildcard in case only Build-Depends-Indep are installed.
 
 # gprbuild.gpr selects inlining.
@@ -120,7 +121,7 @@
         | obj/shared obj/shared_$(library)_ali obj/shared_$(library)_obj
     # -fPIC/-shared overrides -fPIE/-pie in ADAFLAGS/LDFLAGS.
 	gnatmake -c $$($(library)_unit_bodies) -D obj/shared_$(library)_obj \
-	  $(BUILDER_OPTIONS) $(includes_so_far) $(ada_build_deps_includes) \
+	  $(GNATMAKEFLAGS) $(includes_so_far) $(ada_build_deps_includes) \
 	  -cargs $(ADAFLAGS) -fPIC
 	gcc-$(GNAT_VERSION) $(LDFLAGS) -shared \
 	  -o $$@ \
@@ -133,7 +134,7 @@
 	mv obj/shared_$(library)_obj/*.ali obj/shared_$(library)_ali
 	chmod 444 obj/shared_$(library)_ali/*
   # Work-around until BUILD_PATH_PREFIX_MAP is accepted in GCC.
-	sed -i '/^A -f[a-z]+-prefix-map=/d' obj/shared_$(library)_ali/*
+	sed -i '/^A -f[a-z]\+-prefix-map=/d' obj/shared_$(library)_ali/*
 
   # Build static library.
   override_dh_auto_build-arch: obj/static/lib$(library).a
@@ -145,7 +146,7 @@
          $(shared_objects_so_far) \
         | obj/static obj/static_$(library)_ali obj/static_$(library)_obj
 	gnatmake -c $$($(library)_unit_bodies) -D obj/static_$(library)_obj \
-	  $(BUILDER_OPTIONS) $(includes_so_far) $(ada_build_deps_includes) \
+	  $(GNATMAKEFLAGS) $(includes_so_far) $(ada_build_deps_includes) \
 	  -cargs $(ADAFLAGS)
 	ar rc $$@ obj/static_$(library)_obj/*.o
 	ranlib $$@
@@ -179,14 +180,14 @@
 	dh_install --package=$($(library)_DEV_PKG) \
 	  $($(library)_SRCDIR)/*.ad[bs] $$($(library)_c_sources) \
 	  $(ADS_DIR)/$(library)
+
   # Substitution variables for the control file.
-	echo 'ada:Depends=gnat, gnat-$(GNAT_VERSION), \
+  override_dh_gencontrol::
+	dh_gencontrol --package=$($(library)_DEV_PKG) -- -Vada:Depends='\
+	  gnat (>= $(GNAT_VERSION)), \
+	  gnat (<< $(shell expr $(GNAT_VERSION) + 1)), \
 	  $(foreach l, $($(library)_deps_int_direct), $($(l)_DEV_PKG) (=$$$${binary:Version}),) \
 	  $(foreach l, $($(library)_deps_ext_direct), $($(l)_DEV_PKG),) \
-	  $($(library)_LIB_PKG)' \
-	  >> debian/$($(library)_DEV_PKG).substvars
+	  $($(library)_LIB_PKG)'
 
   # Externally built project installed for end users.
-  override_dh_auto_build-arch: obj/$(library).gpr
-  obj/$(library).gpr: debian/template.gpr | obj
-	sed ' \

=== debian/tests/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Tests: ada-policy-project-with-dash-s link-with-shared gpr-wrapper
 Depends: @, gnat
 
-Tests: link-library-as-needed-z-defs source-date-epoch
+Tests: link-library-as-needed-z-defs source-date-epoch mixing-ada-c
 Depends: gprbuild, gnat
 
 Tests: examples

## gprbuild 2023.0.0

=== Makefile ===
--- 
+++ 
@@ -40,12 +40,12 @@
 # target options for cross-build
 ifeq ($(HOST),$(TARGET))
 GTARGET=
-INSTALLER=exe/$(BUILD)/$(LIB_INSTALLER)
+# INSTALLER=exe/$(BUILD)/$(LIB_INSTALLER)
 else
 GTARGET=--target=$(TARGET)
+endif
+
 INSTALLER=$(LIB_INSTALLER)
-endif
-
 EXEC_INSTALLER=$(INSTALLER) -XBUILD=${BUILD}
 
 # check for out-of-tree build

=== examples/libraries/Makefile ===
all: default.cgpr
	gprbuild -p -Pmain0 $(GPRBUILDFLAGS)
	gprbuild -p -Pmain1 $(GPRBUILDFLAGS)
	gprbuild -p -Pmain2 $(GPRBUILDFLAGS)
	gprbuild -p -Pmain3 $(GPRBUILDFLAGS)
	gprbuild -p -Pmain4 $(GPRBUILDFLAGS)

default.cgpr:
	gprconfig --batch --config Ada --config C

clean: default.cgpr
	gprclean -r -Pmain0
	gprclean -r -Pmain1
	gprclean -r -Pmain2
	gprclean -r -Pmain3
	gprclean -r -Pmain4
	$(RM) default.cgpr

run: all
	./main0
	./main1
	PATH="lib2:$$PATH" ./main2
	PATH="lib3:$$PATH" ./main3
	PATH="lib2:$$PATH" ./main4

.PHONY: all clean run

=== debian/changelog ===
gprbuild (2023.0.0-3) unstable; urgency=medium

  * Break/Replace libgnatprj*-dev since oldstable. Closes: #1034913.

 -- Nicolas Boulenguez <nicolas@debian.org>  Wed, 10 May 2023 23:33:22 +0200

gprbuild (2023.0.0-2) unstable; urgency=medium

  * Reupload to unstable for the gnat-12 transition.
  * Standards-Version: 4.6.2 (no changes).

 -- Nicolas Boulenguez <nicolas@debian.org>  Mon, 26 Dec 2022 23:43:38 +0100

gprbuild (2023.0.0-1) experimental; urgency=medium

  * New upstream version.
  * Build with unicode 15. No need to rename -dev in experimental.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 26 Nov 2022 10:42:31 +0000

gprbuild (2023~20220801-3) experimental; urgency=medium

  * Avoid variables set by packaging.mk during -indep builds.

 -- Nicolas Boulenguez <nicolas@debian.org>  Mon, 29 Aug 2022 18:33:59 +0000

gprbuild (2023~20220801-2) experimental; urgency=medium

  * Update debian/rules for dh-ada-library 8.1.
    Various simplifications in sync with the ones in libxmlada.

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 18 Aug 2022 23:35:39 +0000

gprbuild (2023~20220801-1) experimental; urgency=medium

  * Build new upstream snapshot with gnat-12 in experimental.
    Change ALI and SO versions for the library.
  * Depend on gprconfig-kb recent enough for Bindfile_Option_Substitution.
  * When mixing Ada and C, recommend to only match major version.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 07 Aug 2022 06:42:00 +0000

gprbuild (2022.0.0-9) unstable; urgency=medium

  * Move basic test of projects mixing Ada and C to gprconfig-kb.
    Let examples which are mixing languages use the same GCC version too.
  * Improve wording and examples in README.Debian.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 16 Jul 2022 18:53:36 +0000

=== debian/control ===
--- 
+++ 
@@ -6,14 +6,14 @@
 Build-Depends:
  debhelper-compat (= 13),
 Build-Depends-Arch:
- gnat,
-# d/rules extracts ALI versions from these lines:
-# A change in s-oscons.ads breaks ALI checksums:
- gnat-11 (>= 11.2.0-19),
- libxmlada-dom11-dev,
- libxmlada-input11-dev,
- libxmlada-sax11-dev,
- libxmlada-schema11-dev,
+ dh-ada-library (>= 8.1),
+ dh-sequence-ada-library,
+# The GNAT major version must be the same in debian/tests/control.
+ gnat-12,
+ libxmlada-dom12-dev,
+ libxmlada-input12-dev,
+ libxmlada-sax12-dev,
+ libxmlada-schema12-dev,
 # libxmlada_unicode is required indirectly
 Build-Depends-Indep:
  dh-sequence-sphinxdoc,
@@ -28,13 +28,13 @@
  texlive-fonts-recommended,
 # fncychap.sty:
  texlive-latex-extra,
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://github.com/AdaCore/gprbuild
 Vcs-Browser: https://salsa.debian.org/debian/gprbuild
 Vcs-Git: https://salsa.debian.org/debian/gprbuild.git
 
-Package: libgnatprj9
+Package: libgnatprj10
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -46,7 +46,9 @@
  .
  This package contains the runtime shared library.
 
-Package: libgnatprj9-dev
+Package: libgnatprj10-dev
+Breaks: libgnatprj7-dev, libgnatprj8-dev, libgnatprj9-dev
+Replaces: libgnatprj7-dev, libgnatprj8-dev, libgnatprj9-dev
 Section: libdevel
 Architecture: any
 Depends: ${misc:Depends}, ${ada:Depends}
@@ -61,8 +63,8 @@
 Package: gprbuild
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends},
-# 22.0.0-5 nevers calls gnatgcc
- gprconfig-kb (>= 22.0.0-5),
+# 23~20220701-1 sets the now required Bindfile_Option_Substitution attribute
+ gprconfig-kb (>= 23~20220701-1),
 Suggests: gnat, g++, gcc, gfortran, gprbuild-doc
 Description: multi-language extensible build tool
  A set of tools for processing GNAT project files:

=== debian/rules ===
#!/usr/bin/make -f
# Build script for GPRBuild in Debian.
# Copyright (c) 2009-2012 Stephen Leake <stephen_leake@stephe-leake.org>
# Copyright (c) 2013-2022 Nicolas Boulenguez <nicolas@debian.org>

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.

# On Debian systems, the full text of the GPL is in the file
# /usr/share/common-licenses/GPL-3.

# NOTE:
# In order to prevent a circular build-dependency, the Debian packages
# for XML/Ada and GPRBuild bother to build without project support.
# Please keep the two debian/rules files similar enough to ease
# backport of good ideas.

######################################################################

DEB_BUILD_MAINT_OPTIONS := hardening=+all
DEB_ADAFLAGS_MAINT_APPEND := -gnatwa -Wall -gnatn
DEB_LDFLAGS_MAINT_APPEND := \
  -Wl,--no-undefined \
  -Wl,--no-copy-dt-needed-entries \
  -Wl,--no-allow-shlib-undefined
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/buildopts.mk
include $(wildcard /usr/share/ada/packaging.mk)
# wildcard in case only Build-Depends-Indep are installed.

# gprbuild.gpr selects inlining.
# It also selects -E -static binder options, but:
# #666106 affects only kfreebsd-i386, where storing tracebacks in
# exception occurrences causes a segmentation fault.  This prevents
# handling of any exceptions.  gprconfig relies on handling exceptions
# when parsing compilers.xml.
# Author: Ludovic Brenta <lbrenta@debian.org>

######################################################################
%:
	dh $@

# Rewrite upstream configure/make build system.
.PHONY: $(addprefix override_dh_auto_, \
  configure build-arch build-indep test install-arch install-indep clean)

# gnatmake does not support projects anymore, we cannot use xmlada.gpr.
# The priority is to bootstrap, not a complete dependency graph.

override_dh_auto_build-arch::
	ln -fs gpr-util-put_resource_usage__unix.adb gpr/src/gpr-util-put_resource_usage.adb
	mkdir -p obj

######################################################################

# For source directories (-aI) and ALI directories (-aO), blindly list
# all build dependencies and append each library once it is
# built. This does not hurt, and covers all direct and indirect
# dependencies.

# For installed shared libraries (-l) and locally built shared
# objects), the same strategy works thanks to --as-needed, which is
# the default since gcc-9, provided a proper ordering.

# Libraries provided by Ada -dev packages in Build-Depends.
ada_build_deps := xmlada_schema xmlada_dom xmlada_sax xmlada_input xmlada_unicode

# These list grow each time the template is expanded.
gnatmakeflags := $(GNATMAKEFLAGS) \
                 $(ada_build_deps:%=-aI/$(DEB_ADA_SOURCE_DIR)/%) \
                 $(ada_build_deps:%=-aO/$(DEB_ADA_LIB_INFO_DIR)/%)
shared_objects_so_far := $(ada_build_deps:%=-l%) \
                         -lgnarl-$(DEB_GNAT_VERSION) \
                         -lgnat-$(DEB_GNAT_VERSION)

define library_template
# Parameters:
# _SRCDIR: directory containing the sources files
# _SO_VERSION : part of the shared object name
# _imported_projects: for the generated project.

  override_dh_auto_build-arch::

	mkdir -p obj/shared_$1 obj/static_$1

  # Build dynamic library.
    # -fPIC/-shared overrides -fPIE/-pie in ADAFLAGS/LDFLAGS.
	gcc-$(DEB_GNAT_VERSION) -c $($1_SRCDIR)/gpr_imports.c \
	  $(CFLAGS) $(CPPFLAGS) -o obj/shared_$1/gpr_imports.o -fPIC
	gnatmake -c `grep -L '^separate ' $($1_SRCDIR)/*.ad[bs]` \
	  $(gnatmakeflags) -D obj/shared_$1 -cargs $(ADAFLAGS) -fPIC
	gcc-$(DEB_GNAT_VERSION) -shared \
	  -o obj/lib$1.so.$($1_SO_VERSION) \
	  -Wl,-soname,lib$1.so.$($1_SO_VERSION) \
	  $(LDFLAGS) obj/shared_$1/*.o $(shared_objects_so_far)

  # Mark ALI files as read-only.
	chmod 444 obj/shared_$1/*.ali

  # Build static library.
	gcc-$(DEB_GNAT_VERSION) -c $($1_SRCDIR)/gpr_imports.c \
	  $(CFLAGS) $(CPPFLAGS) -o obj/static_$1/gpr_imports.o
	gnatmake -c `grep -L '^separate ' $($1_SRCDIR)/*.ad[bs]` \
	  $(gnatmakeflags) -D obj/static_$1 -cargs $(ADAFLAGS)
	ar rc obj/lib$1.a obj/static_$1/*.o
	ranlib obj/lib$1.a

  # Externally built project installed for end users.
	sed ' \
	  /@IMPORTS@/ { \
	    s//$($1_imported_projects:%=with "%.gpr";\n)/; \
	    s/\n /\n/g; }; \
	  s/@library@/$1/; \
	  s|@DEB_LIB_DIR@|$(DEB_LIB_DIR)|; \
	  s|@DEB_ADA_SOURCE_DIR@|$(DEB_ADA_SOURCE_DIR)|; \
	  s|@DEB_ADA_LIB_INFO_DIR@|$(DEB_ADA_LIB_INFO_DIR)|; \
	  ' debian/template.gpr > obj/$1.gpr

  override_dh_auto_install-arch::
	install -m644 -Dtdebian/tmp/$(DEB_ADA_SOURCE_DIR)/$1 $($1_SRCDIR)/*.ad[bs] \
	  $($1_SRCDIR)/gpr_imports.c
	install -m444 -Dtdebian/tmp/$(DEB_ADA_LIB_INFO_DIR)/$1 obj/shared_$1/*.ali
	install -m644 -Dtdebian/tmp/$(DEB_GNAT_PROJECT_DIR) obj/$1.gpr
	install -m644 -Dtdebian/tmp/$(DEB_LIB_DIR) \
	  obj/lib$1.so.$($1_SO_VERSION) obj/lib$1.a
	ln -fs lib$1.so.$($1_SO_VERSION) debian/tmp/$(DEB_LIB_DIR)/lib$1.so

  gnatmakeflags += -aI$($1_SRCDIR) -aOobj/shared_$1
  shared_objects_so_far := obj/lib$1.so.$($1_SO_VERSION) \
                           $(shared_objects_so_far)
endef

gnatprj_SRCDIR := gpr/src
gnatprj_imported_projects := xmlada_schema xmlada_dom xmlada_sax xmlada_input
$(eval $(call library_template,gnatprj))

######################################################################

args_for_tools := \
  -D obj $(gnatmakeflags) \
  -cargs $(ADAFLAGS) \
  -largs $(LDFLAGS) $(shared_objects_so_far)

override_dh_auto_build-arch::
	gnatmake src/gprbind.adb         -o obj/gprbind    $(args_for_tools)
	gnatmake src/gprbuild-main.adb   -o obj/gprbuild   $(args_for_tools)
	gnatmake src/gprclean-main.adb   -o obj/gprclean   $(args_for_tools)
	gnatmake src/gprconfig-main.adb  -o obj/gprconfig  $(args_for_tools)
	gnatmake src/gprinstall-main.adb -o obj/gprinstall $(args_for_tools)
	gnatmake src/gprlib.adb          -o obj/gprlib     $(args_for_tools)
	gnatmake src/gprls-main.adb      -o obj/gprls      $(args_for_tools)
	gnatmake src/gprname-main.adb    -o obj/gprname    $(args_for_tools)
	gnatmake src/gprslave.adb        -o obj/gprslave   $(args_for_tools)

######################################################################
override_dh_auto_build-indep:
  ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
    # Replace sphinx.sty copy with packaged one.
	ln -fs /usr/share/sphinx/texinputs/sphinx.sty doc/share/sphinx.sty
    # Enable parallelism in sphinx, but not in Make (#1008152).
	$(MAKE) -C doc html pdf txt \
	  $(DEB_BUILD_OPTION_PARALLEL,%=SPHINXOPTS=-j%)
  endif
override_dh_auto_clean:
	$(MAKE) -Cdoc clean

# Compatibility project with upstream name GPR.
execute_after_dh_install-arch:
	dh_install --package=$(gnatprj_DEV_PKG) debian/gpr.gpr \
	  $(DEB_GNAT_PROJECT_DIR)

=== debian/tests/control ===
Tests: archive-builder
Depends: gprbuild, gcc

Tests: ada-policy-project-with-dash-s link-with-shared gpr-wrapper
Depends: @, gnat

Tests: link-library-as-needed-z-defs source-date-epoch
Depends: gprbuild, gnat

Tests: examples
Depends: gprbuild, gnat, gnat-12, gcc-12, g++-12, gfortran-12, make, gprbuild-doc

Tests: do-not-strip-minor-soversion
Depends: gprbuild, gnat, binutils
